## qt4-x11 4.8.6+git64-g5dc8b2b+dfsg

=== debian/changelog ===
qt4-x11 (4:4.8.6+git64-g5dc8b2b+dfsg-3~ubuntu8) wily; urgency=medium

  * Build using GCC 5.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 12 Jul 2015 21:12:40 +0200

qt4-x11 (4:4.8.6+git64-g5dc8b2b+dfsg-3~ubuntu7) wily; urgency=medium

  * SECURITY UPDATE: denial of service via crafted BMP
    - debian/patches/CVE-2015-0295.patch: fix division by zero in
      src/gui/image/qbmphandler.cpp.
    - CVE-2015-0295
  * SECURITY UPDATE: denial of service and possible code execution via
    crafted BMP or ICO images
    - debian/patches/CVE-2015-1858-1859.patch: move check to better
      location in src/gui/image/qbmphandler.cpp, check depth in
      src/plugins/imageformats/ico/qicohandler.cpp.
    - CVE-2015-1858
    - CVE-2015-1859
  * SECURITY UPDATE: denial of service and possible code exection via
    crafted GIF image
    - debian/patches/CVE-2015-1860.patch: check bounds in
      src/gui/image/qgifhandler.cpp.
    - CVE-2015-1860

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 03 Jun 2015 09:34:49 -0400

qt4-x11 (4:4.8.6+git64-g5dc8b2b+dfsg-3~ubuntu6) vivid; urgency=medium

  * Fix detection of GCC 5.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 06 Mar 2015 12:10:22 +0100

qt4-x11 (4:4.8.6+git64-g5dc8b2b+dfsg-3~ubuntu5) vivid; urgency=medium

  * Add kubuntu_qclipboard_delay.diff to fix KDE dialogs in LibreOffice
  * Add kubuntu_qclipboard_fix_recursive.diff to fix crash in clipboard
    in LibreOffice with Qt style

 -- Jonathan Riddell <jriddell@ubuntu.com>  Sat, 22 Nov 2014 15:39:41 +0100

qt4-x11 (4:4.8.6+git64-g5dc8b2b+dfsg-3~ubuntu4) vivid; urgency=medium

  * kubuntu_43_no_meego_helper.patch: Patch in one more location.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Tue, 04 Nov 2014 21:29:04 +0300

qt4-x11 (4:4.8.6+git64-g5dc8b2b+dfsg-3~ubuntu3) vivid; urgency=medium

  * kubuntu_43_no_meego_helper.patch: Don’t build QtMeegoGraphicsSystemHelper,
    useless on non-MeeGo systems.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Tue, 04 Nov 2014 17:37:26 +0300

qt4-x11 (4:4.8.6+git64-g5dc8b2b+dfsg-3~ubuntu2) vivid; urgency=medium

  * Drop the hacks to build QtWebKit for Assistant, as we now have Assistant
    from Qt 5.x properly built against QtWebKit 5.x.
  * Drop kubuntu_31_unity_workarea_atom.diff, it was needed only for Unity 2D.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Sun, 02 Nov 2014 14:56:51 +0300

qt4-x11 (4:4.8.6+git64-g5dc8b2b+dfsg-3~ubuntu1) vivid; urgency=medium

  * Merge with Debian git, remaining changes:
    - Pass list-missing to dh_install instead of fail-missing, since we don't
      install the QtWebkit headers
    - Make sure libqt4-opengl-dev depends on gles libs for armel and armhf
    - Do not package ibase/firebird and sqlite2 package
      + remove from debian/control
      + libqt4-sql doesn't recommend libqt4-sql-ibase and libqt4-sql-sqlite2
    - Build QtWebkit and use it only for QtAssistant
      + Rule to put qt_webkit_version.pri in mkspecs/modules
      + Rule to remove libQtWebKit* after build
      + Exclude bin/assistant from dh_shlibdeps
    - Also exclude webkit examples from dh_shlibdeps
    - Do not build libqt4-phonon, disable in debian/control
    - Add debian/Trolltech.conf and install it in libqtcore4.install
    - On armel and armhf, build with -gstabs instead of -g in an effort to get
      the link step for QtWebkit to complete before timed out by the builders
    - Build with -no-neon on armel and armhf
    - Build with -no-javascript-jit on arm64
    - Add patches:
      + kubuntu_10_ibus_input_method.diff
      + kubuntu_12_fix_stack_protector.diff
      + kubuntu_14_systemtrayicon.diff
      + kubuntu_17_enable_qtwebkit_for_qtassistant.diff
      + kubuntu_28_xi2.1.patch
      + kubuntu_30_translucent_drag_pixmap.diff
      + kubuntu_31_unity_workarea_atom.diff
      + kubuntu_37_cups_settings.diff
      + kubuntu_39_fix_medium_font.diff
      + kubuntu_40_disable_neon.patch
      + kubuntu_93_disable_overlay_scrollbars.diff
      + kubuntu_94_xinput_valuators_fix.diff
      + kubuntu_95_qt_disable_bounce.diff
      + kubuntu_97_a11y_qt_and_qml_backport.diff
      + kubuntu_98_a11y_fix_crash.diff
      + kubuntu_glib-honor-ExcludeSocketNotifiers-flag.diff
    - Drop powerpc_designer_gstabs.diff, it breaks powerpc

 -- Jonathan Riddell <jriddell@ubuntu.com>  Wed, 29 Oct 2014 16:20:32 +0100

qt4-x11 (4:4.8.6+git64-g5dc8b2b+dfsg-3) UNRELEASED; urgency=medium

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * Remove aarch64_arm64_mkspecs.patch, as it's not really needed. Simply use
    platform_arg = linux-g++ for it.
  * Add two more files to override_dh_auto_clean.
  * Remove GStreamer 0.1's build dependencies. The real users of it
    should be using phonon with GStreamer 1.0.

 -- Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>  Sat, 06 Sep 2014 19:50:03 -0300

qt4-x11 (4:4.8.6+git64-g5dc8b2b+dfsg-2) unstable; urgency=medium

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * Remove debian/NEWS, it's no longer accurate.
  * Update symbols files with buildds' logs.

  [ Adam Majer ]
  * Add xmlpatterns_stack_overflow_fix.diff which changes a recursive call
    into iteration fixing stack overflow in XmlPatterns.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Thu, 04 Sep 2014 16:25:52 -0300

qt4-x11 (4:4.8.6+git64-g5dc8b2b+dfsg-1) unstable; urgency=medium

  * New upstream snapshot.
  * Disable the use of system proxies by default. It seems that if http_proxy
    is setted then all protocols try to use the proxy.
  * Add support for arm64 (Closes: #735488).
    - Make arm64 use linux-g++ as platform_arg.
    - Fix arch detection.
    - Add qatomic support. This patch is known to not be the most correct way
      to implement them, as it seems to be possible to do it in a faster way,
      but should work non the less until we can provide something better.
    - Add arm64's mkspecs.
  * Add support for ppc64el (Closes: #749743).
    - Add ppc64el to 07_trust_dpkg-arch_over_uname-m.diff, as the uname output


=== debian/control ===
Source: qt4-x11
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian/Kubuntu Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Fathi Boudra <fabo@debian.org>,
           Modestas Vainius <modax@debian.org>,
           Sune Vuorela <debian@pusling.com>,
           Pino Toscano <pino@debian.org>,
           Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>,
           Timo Jyrinki <timo@debian.org>
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.16.1),
               flex,
               freetds-dev,
               libasound2-dev [linux-any],
               libaudio-dev,
               libcups2-dev,
               libdbus-1-dev,
               libfreetype6-dev,
               libgl1-mesa-dev [!armel !armhf],
               libgles2-mesa-dev [armel armhf],
               libglib2.0-dev,
               libglu1-mesa-dev [!armel !armhf],
               libgtk2.0-dev,
               libice-dev,
               libicu-dev,
               libjpeg-dev,
               libmng-dev,
               libmysqlclient-dev,
               libpam0g-dev,
               libpng-dev,
               libpq-dev,
               libreadline-dev,
               libsm-dev,
               libsqlite3-dev,
               libssl-dev,
               libtiff-dev,
               libx11-dev,
               libxcursor-dev,
               libxext-dev,
               libxft-dev,
               libxi-dev,
               libxinerama-dev,
               libxmu-dev,
               libxrandr-dev,
               libxrender-dev,
               libxslt1-dev,
               libxt-dev,
               libxtst-dev,
               libxv-dev,
               pkg-kde-tools (>= 0.14.2),
               rsync,
               unixodbc-dev,
               zlib1g-dev
Build-Conflicts: libqtwebkit-dev
Standards-Version: 3.9.5
Homepage: http://qt-project.org/
Vcs-Git: git://anonscm.debian.org/pkg-kde/qt/qt4-x11.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-kde/qt/qt4-x11.git

Package: libqtcore4
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: qtcore4-l10n, ${misc:Depends}, ${shlibs:Depends}
Suggests: libicu52, libthai0
Description: Qt 4 core module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtCore module contains core non-GUI functionality.

Package: qtcore4-l10n
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: libqtcore4 (<< 4:4.8.5+dfsg-1~)
Replaces: libqtcore4 (<< 4:4.8.5+dfsg-1~)
Description: Qt 4 core module translations
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the translations of the QtCore module.

Package: libqt4-core
Architecture: any
Section: oldlibs
Priority: extra
Depends: libqt4-dbus (= ${binary:Version}),
         libqt4-network (= ${binary:Version}),
         libqt4-script (= ${binary:Version}),
         libqt4-test (= ${binary:Version}),
         libqt4-xml (= ${binary:Version}),
         libqtcore4 (= ${binary:Version}),
         ${misc:Depends}
Description: transitional package for Qt 4 core non-GUI runtime libraries
 Qt is a cross-platform C++ application framework.  Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This is a dummy transitional package to enable installation of other packages
 linked against Qt 4.3 or earlier Qt 4 releases previously shipped.

Package: libqtgui4
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: fontconfig, ${misc:Depends}, ${shlibs:Depends}
Recommends: libcups2
Suggests: qt4-qtconfig
Description: Qt 4 GUI module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtGui module extends QtCore with GUI functionality.

Package: libqt4-gui
Architecture: any
Section: oldlibs
Priority: extra
Depends: libqt4-designer (= ${binary:Version}),
         libqt4-opengl (= ${binary:Version}),
         libqt4-svg (= ${binary:Version}),
         libqtgui4 (= ${binary:Version}),
         ${misc:Depends}
Description: transitional package for Qt 4 GUI runtime libraries
 Qt is a cross-platform C++ application framework.  Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This is a dummy transitional package depending on the Qt 4 GUI library
 packages which the package of the same name used to provide in Qt 4.3.4
 and earlier packages of Qt 4.

Package: libqt4-network
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: ca-certificates
Description: Qt 4 network module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtNetwork module offers classes that allow you to write TCP/IP clients and
 servers. It provides classes to make network programming easier and portable.

Package: libqt4-opengl
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 4 OpenGL module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtOpenGL module offers classes that make it easy to use OpenGL in Qt
 applications.
 .
 OpenGL is a standard API for rendering 3D graphics. OpenGL only deals with 3D
 rendering and provides little or no support for GUI programming issues.

Package: libqt4-script
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 4 script module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtScript module provides classes for making Qt applications scriptable.

Package: libqt4-scripttools
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 4 script tools module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtScriptTools module provides additional components for applications that
 use Qt Script.
 .
 This package contains the Qt Script debugger, a tool for debugging script
 execution in Qt applications that use Qt Script.

Package: libqt4-sql
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: libqt4-sql-mysql | libqt4-sql-odbc | libqt4-sql-psql | libqt4-sql-sqlite
Suggests: libqt4-dev
Description: Qt 4 SQL module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtSql module helps you provide seamless database integration to your Qt
 applications.
 .
 If you wish to use the SQL module for development, you should install the
 libqt4-dev package.

Package: libqt4-sql-mysql
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libqt4-dev
Description: Qt 4 MySQL database driver
 This package contains the MySQL plugin for Qt 4.
 .
 Install it if you intend to use or write Qt programs that are to access a
 MySQL DB.

Package: libqt4-sql-odbc
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libqt4-dev
Description: Qt 4 ODBC database driver
 This package contains the ODBC plugin for Qt 4.
 .
 Install it if you intend to use or write Qt programs that are to access an
 ODBC DB.

Package: libqt4-sql-psql
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libqt4-dev
Description: Qt 4 PostgreSQL database driver
 This package contains the PostgreSQL plugin for Qt 4.
 .
 Install it if you intend to use or write Qt programs that are to access a
 PostgreSQL DB.

Package: libqt4-sql-sqlite
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libqt4-dev
Description: Qt 4 SQLite 3 database driver
 This package contains the SQLite 3 plugin for Qt 4.
 .
 Install it if you intend to use or write Qt programs that are to access an
 SQLite 3 DB.

Package: libqt4-sql-tds
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libqt4-dev
Description: Qt 4 FreeTDS database driver
 This package contains the FreeTDS plugin for Qt 4.
 .
 Install it if you intend to use or write Qt programs that are to access a
 MS SQL or Sybase SQL server.

Package: libqt4-svg
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 4 SVG module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtSvg module provides classes for displaying the contents of SVG files.
 .
 Scalable Vector Graphics (SVG) is a language for describing two-dimensional
 graphics and graphical applications in XML.

Package: libqt4-webkit
Architecture: any
Section: oldlibs
Priority: extra
Depends: libqtwebkit4 (>= 2.0~), ${misc:Depends}
Description: transitional package for Qt 4 WebKit module
 Qt is a cross-platform C++ application framework.  Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This is a dummy transitional package to enable installation of other packages
 linked against Qt WebKit 4.4 - 4.6 releases previously shipped from Qt source.

Package: libqt4-xml
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 4 XML module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtXml module provides a stream reader and writer for XML documents,
 and C++ implementations of SAX and DOM.

Package: libqt4-xmlpatterns
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 4 XML patterns module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 QtXmlPatterns is a XQuery and XPath engine for XML and custom data models.

Package: libqt4-dbus
Architecture: any
Multi-Arch: same
Depends: libqtdbus4 (= ${binary:Version}),
         qdbus (= ${binary:Version}),
         ${misc:Depends}
Replaces: libqt4-dev (<< 4:4.7.1)
Breaks: libqt4-dev (<< 4:4.7.1)
Description: Qt 4 D-Bus module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtDBus module is a Unix-only library that you can use to make Inter-Process
 Communication using the D-Bus protocol.
 .
 Applications using the QtDBus module can provide services to other, remote
 applications by exporting objects, as well as use services exported by those
 applications by placing calls and accessing properties.

Package: libqtdbus4
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libqt4-dbus (<< 4:4.8.2+dfsg-8)
Replaces: libqt4-dbus (<< 4:4.8.2+dfsg-8)
Description: Qt 4 D-Bus module library
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export QTDIR := $(shell pwd)
export PATH := $(QTDIR)/bin:$(PATH)
export CFLAGS := $(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
export CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
# Use -gstabs instaed of -g on armel and armhf to make the link step complete
# within buildd limitations
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), armel armhf))
export CFLAGS := $(CFLAGS:-g=-gstabs)
export CXXFLAGS := $(CXXFLAGS:-g=-gstabs)
endif
ifneq (,$(filter $(DEB_HOST_ARCH),arm64))
export CXXFLAGS := -fpermissive $(CXXFLAGS)
endif
export LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed
# workaround to use lrelease.
export LD_LIBRARY_PATH := $(QTDIR)/lib:$(LD_LIBRARY_PATH)
# workaround to use qhelpgenerator.
export QT_PLUGIN_PATH := $(QTDIR)/plugins

# Packages with own debug package
pkgs_dbg := $(shell dh_listpackages | grep dbg | sed -e '/libqt4-dbg/d; s|-dbg||')
# Packages whose debug symbols belong to qt4-bin-dbg
pkgs_dbgbin := libqt4-dev-bin $(filter-out %-dbg lib% $(pkgs_dbg),$(shell dh_listpackages))
# Library package list for override_dh_makeshlibs, excludes libqt4-phonon
pkgs_lib := $(filter-out %-dev %-dbg libqt4-phonon libqt4-dev-bin,$(filter lib%,$(shell dh_listpackages)))
# Upstream changelog
upstream_changes := $(wildcard changes-*)
# Current debian version (e.g.: 4:4.5.2-1)
current_version := $(shell dpkg-parsechangelog | sed -n 's/^Version: //p')
# Specific shlibs version (e.g.: 4:4.5.2)
shlibs_version := $(shell dpkg-parsechangelog | sed -n 's/^Version: //p' | cut -f1 -d '-')
# libqt4-phonon shlibs. Minimum libphonon4 version may need adjusting for new
# Qt upstream release
libqt4phonon_shlibs := libphonon4 (>= 4:4.6.0) | libqt4-phonon (= $(current_version))
# Distribution vendor
vendor := $(shell dpkg-vendor --query Vendor)

ifneq (,$(filter %-sql-ibase,$(shell dh_listpackages)))
	extra_configure_opts += -plugin-sql-ibase
else
	extra_configure_opts += -no-sql-ibase
endif

ifneq (,$(filter %-sql-sqlite2,$(shell dh_listpackages)))
	extra_configure_opts += -plugin-sql-sqlite2
else
	extra_configure_opts += -no-sql-sqlite2
endif

ifeq ($(DEB_HOST_ARCH),arm)
	extra_configure_opts += -DQT_QLOCALE_USES_FCVT
endif

armv6_architectures := armhf
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(armv6_architectures)))
	extra_configure_opts += -arch armv6
endif

ifeq ($(vendor),Ubuntu)
gles2_architectures := armel armhf
else
gles2_architectures := none_for_now
endif
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(gles2_architectures)))
	extra_configure_opts += -opengl es2 -no-neon
else
	extra_configure_opts += -opengl desktop \
	                        -no-egl
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
  ifneq (,$(filter $(DEB_HOST_ARCH),alpha ia64 mips64 mips64el))
	platform_arg = linux-g++
  else ifeq ($(DEB_HOST_ARCH),arm64)
	# arm64 does not uses -m64, so avoid linux-g++-64.
	platform_arg = linux-g++
  else ifeq ($(DEB_HOST_ARCH_BITS),64)
	platform_arg = linux-g++-64
  else
	platform_arg = linux-g++
  endif
else
  ifeq ($(DEB_HOST_ARCH_OS),hurd)
	platform_arg = hurd-g++
  else
	platform_arg = glibc-g++
  endif
endif

no_pch_architectures := arm64 armhf ia64 powerpc ppc64 ppc64el
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(no_pch_architectures)))
	extra_configure_opts += -no-pch
endif

%:
	dh $@ --parallel --with pkgkde_symbolshelper

override_dh_auto_configure:
	# Test broken hppa kernel with glibc >= 2.5
ifeq ($(DEB_HOST_ARCH),hppa)
	mkdir -p debian/hppa-tmp
	echo "Testing whether getdents kernel bug is present on this buildd - see #433768"
	gcc -o debian/hppa-tmp/hppa-test-program debian/readdir-hppa-test.c
	cd $(CURDIR)/doc/src/images && $(CURDIR)/debian/hppa-tmp/hppa-test-program | sort > $(CURDIR)/debian/hppa-tmp/readdir_r-out
	cd $(CURDIR)/doc/src/images && ls -a | sort > $(CURDIR)/debian/hppa-tmp/ls-a-out
	@if ! diff -q $(CURDIR)/debian/hppa-tmp/readdir_r-out $(CURDIR)/debian/hppa-tmp/ls-a-out ; \
		then \
		echo "Kernel bug present. This will misbuild qt4 if proceeding. Failing" ; \
		echo "Please update kernel and test again" ; \
		exit 5 ; \
	fi
endif

	# Create mkspecs/glibc-g++ from mkspecs/linux-g++, needed by GNU/kFreeBSD
	# we cannot use directly linux-g++ due to src/corelib/io/io.pri
	rm -rfv mkspecs/glibc-g++
	cp -a mkspecs/linux-g++ mkspecs/glibc-g++

	# Remove include directory. Then ./configure will take care of calling
	# syncqt and regenerating it.
	rm -rfv include

	./configure -confirm-license \
	            -prefix "/usr" \
	            -bindir "/usr/lib/$(DEB_HOST_MULTIARCH)/qt4/bin" \
	            -libdir "/usr/lib/$(DEB_HOST_MULTIARCH)" \
	            -docdir "/usr/share/qt4/doc" \
	            -headerdir "/usr/include/qt4" \
	            -datadir "/usr/share/qt4" \
	            -plugindir "/usr/lib/$(DEB_HOST_MULTIARCH)/qt4/plugins" \
	            -importdir "/usr/lib/$(DEB_HOST_MULTIARCH)/qt4/imports" \
	            -translationdir "/usr/share/qt4/translations" \
	            -sysconfdir "/etc/xdg" \
	            -demosdir "/usr/lib/qt4/demos" \
	            -examplesdir "/usr/lib/qt4/examples" \
	            -opensource \
	            -fast \
	            -plugin-sql-mysql \
	            -plugin-sql-odbc \
	            -plugin-sql-psql \
	            -plugin-sql-sqlite \
	            -plugin-sql-tds \
	            -system-sqlite \
	            -xmlpatterns \
	            -no-multimedia \
	            -audio-backend \
	            -no-phonon \
	            -no-phonon-backend \
	            -svg \
	            -no-webkit \
	            -script \
	            -scripttools \
	            -platform $(platform_arg) \
	            -system-zlib \
	            -system-libtiff \
	            -system-libpng \
	            -system-libjpeg \
	            -no-rpath \
	            -optimized-qmake \
	            -dbus-linked \
	            -reduce-relocations \
	            -no-separate-debug-info \
	            -verbose \
	            -gtkstyle \
	            -system-nas-sound \
	            -no-openvg \
	            -lfontconfig \
	            -I/usr/include/freetype2 \
	            -qvfb \
	            -icu \
	            $(extra_configure_opts)

override_dh_auto_build:
	dh_auto_build
	# Build documentations
ifneq (,$(filter qt4-doc, $(shell dh_listpackages)))
	# Build documentations
	dh_auto_build -Smakefile -- docs
endif
	# Build translations
	dh_auto_build -Smakefile -- -C translations ts-all
	# Workaround: It's a known qmake limitation.
	# It can't generate install rules for files that don't exist yet like docs.
	./config.status

override_dh_auto_clean:
	[ ! -f Makefile ] || $(MAKE) confclean distclean

	# Extra stuff missed by confclean/distclean

	# Misc. files
	rm -fv \
	  .qmake.vars \
	  config.status \
	  config.tests/.qmake.cache \
	  examples/dbus/*/Makefile.* \
	  mkspecs/qconfig.pri \
	  src/corelib/global/qconfig.* \
	  src/tools/uic/qclass_lib_map.h \
	;

	# Misc. directories
	rm -rfv \
	  doc-build/ \
	  doc/html/ \
	  doc/qch/ \
	  examples/tools/plugandpaint/plugins/ \
	  examples/tools/styleplugin/styles/ \
	  include/ \
	  lib/ \
	  mkspecs/glibc-g++/ \
	  plugins/ \
	;

	# hppa test directory
	rm -rfv debian/hppa-tmp

	# Leftover dirs
	find -depth -type d \( -false \
	  -o -name debug-shared \
	  -o -name debug-static \
	  -o -name \*.gch \
	  -o -name .moc\* \
	  -o -name .obj\* \
	  -o -name .pch \
	  -o -name pkgconfig \
	  -o -name .rcc \
	  -o -name release-shared \
	  -o -name release-static \
	  -o -name .uic \
	\) -print0 | xargs -0 rm -rfv

	# Leftover files and all symlinks
	find \( -false \
	  -o -name \*.a \
	  -o -name Makefile.Debug \
	  -o -name Makefile.Release \
	  -o -name \*.o \
	  -o -name \*.prl \
	  -o -name \*.so \
	  -o -name \*.so.debug \
	  -o -type l \
	\) -print0 | xargs -0 rm -rfv

## qt4-x11 4.8.7%2Bdfsg

=== src/3rdparty/webkit/Source/JavaScriptCore/wtf/CMakeLists.txt ===
SET(WTF_HEADERS
    ASCIICType.h
    AVLTree.h
    Alignment.h
    AlwaysInline.h
    Assertions.h
    Atomics.h
    Bitmap.h
    BumpPointerAllocator.h
    ByteArray.h
    Complex.h
    CrossThreadRefCounted.h
    CryptographicallyRandomNumber.h
    CurrentTime.h
    DateMath.h
    DecimalNumber.h
    Decoder.h
    Deque.h
    DisallowCType.h
    DoublyLinkedList.h
    DynamicAnnotations.h
    Encoder.h
    FastAllocBase.h
    FastMalloc.h
    FixedArray.h
    Forward.h
    GetPtr.h
    HashCountedSet.h
    HashFunctions.h
    HashIterators.h
    HashMap.h
    HashSet.h
    HashTable.h
    HashTraits.h
    HexNumber.h
    ListHashSet.h
    ListRefPtr.h
    Locker.h
    MD5.h
    MainThread.h
    MallocZoneSupport.h
    MathExtras.h
    MessageQueue.h
    NonCopyingSort.h
    Noncopyable.h
    NotFound.h
    NullPtr.h
    OSAllocator.h
    OSRandomSource.h
    OwnArrayPtr.h
    OwnFastMallocPtr.h
    OwnPtr.h
    OwnPtrCommon.h
    PageAllocation.h
    PageAllocationAligned.h
    PageBlock.h
    PageReservation.h
    PassOwnArrayPtr.h
    PassOwnPtr.h
    PassRefPtr.h
    PassTraits.h
    ParallelJobs.h
    ParallelJobsGeneric.h
    ParallelJobsLibdispatch.h
    ParallelJobsOpenMP.h
    Platform.h
    PossiblyNull.h
    RandomNumber.h
    RandomNumberSeed.h
    RefCounted.h
    RefCountedLeakCounter.h
    RefPtr.h
    RefPtrHashMap.h
    RetainPtr.h
    SegmentedVector.h
    SHA1.h
    StackBounds.h
    StaticConstructors.h
    StdLibExtras.h
    StringExtras.h
    StringHasher.h
    TCPackedCache.h
    TCPageMap.h
    TCSpinLock.h
    TCSystemAlloc.h
    ThreadIdentifierDataPthreads.h
    ThreadSafeRefCounted.h
    ThreadSpecific.h
    Threading.h
    ThreadingPrimitives.h
    TypeTraits.h
    UnusedParam.h
    VMTags.h
    ValueCheck.h
    Vector.h
    VectorTraits.h
    WTFThreadData.h
    dtoa.h

    text/AtomicString.h
    text/AtomicStringImpl.h
    text/CString.h
    text/StringBuffer.h
    text/StringHash.h
    text/StringImpl.h
    text/StringImplBase.h
    text/WTFString.h

    unicode/CharacterNames.h
    unicode/Collator.h
    unicode/UTF8.h
    unicode/Unicode.h
)

SET(WTF_SOURCES
    Assertions.cpp
    ByteArray.cpp
    CryptographicallyRandomNumber.cpp
    CurrentTime.cpp
    DecimalNumber.cpp
    DynamicAnnotations.cpp
    FastMalloc.cpp
    HashTable.cpp
    MainThread.cpp
    MD5.cpp
    OSRandomSource.cpp
    ParallelJobsGeneric.cpp
    RandomNumber.cpp
    RefCountedLeakCounter.cpp
    SHA1.cpp
    StackBounds.cpp
    StringExtras.cpp
    Threading.cpp
    TypeTraits.cpp
    WTFThreadData.cpp
    dtoa.cpp

    text/AtomicString.cpp
    text/CString.cpp
    text/StringBuilder.cpp
    text/StringImpl.cpp
    text/StringStatics.cpp
    text/WTFString.cpp

    unicode/UTF8.cpp
)

SET(WTF_LIBRARIES
)

SET(WTF_PORT_FLAGS )
INCLUDE_IF_EXISTS(${JAVASCRIPTCORE_DIR}/wtf/CMakeLists${PORT}.txt)

LIST(APPEND WTF_INCLUDE_DIRECTORIES
    "${CMAKE_BINARY_DIR}"
    "${CMAKE_SOURCE_DIR}/ThirdParty"
)

WEBKIT_WRAP_SOURCELIST(${WTF_SOURCES})
INCLUDE_DIRECTORIES(${WTF_INCLUDE_DIRECTORIES})
ADD_DEFINITIONS(-DBUILDING_WTF)
ADD_LIBRARY(${WTF_LIBRARY_NAME} ${WTF_LIBRARY_TYPE} ${WTF_HEADERS} ${WTF_SOURCES})
TARGET_LINK_LIBRARIES(${WTF_LIBRARY_NAME} ${WTF_LIBRARIES})

IF (WTF_LINK_FLAGS)
    ADD_TARGET_PROPERTIES(${WTF_LIBRARY_NAME} LINK_FLAGS "${WTF_LINK_FLAGS}")
ENDIF ()

IF (SHARED_CORE)
    SET_TARGET_PROPERTIES(${WTF_LIBRARY_NAME} PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})
    INSTALL(TARGETS ${WTF_LIBRARY_NAME} DESTINATION lib)
ENDIF ()

=== debian/rules ===
--- 
+++ 
@@ -9,15 +9,6 @@
 export PATH := $(QTDIR)/bin:$(PATH)
 export CFLAGS := $(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
 export CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
-# Use -gstabs instaed of -g on armel and armhf to make the link step complete
-# within buildd limitations
-ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), armel armhf))
-export CFLAGS := $(CFLAGS:-g=-gstabs)
-export CXXFLAGS := $(CXXFLAGS:-g=-gstabs)
-endif
-ifneq (,$(filter $(DEB_HOST_ARCH),arm64))
-export CXXFLAGS := -fpermissive $(CXXFLAGS)
-endif
 export LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed
 # workaround to use lrelease.
 export LD_LIBRARY_PATH := $(QTDIR)/lib:$(LD_LIBRARY_PATH)
@@ -249,3 +240,12 @@
 	  -o -type l \
 	\) -print0 | xargs -0 rm -rfv
 
+	# Delete all Makefiles, excluding some from src/3rdparty
+	find $(CURDIR) -name Makefile \
+	  ! -path $(CURDIR)/src/3rdparty/Makefile \
+	  ! -path $(CURDIR)/src/3rdparty/freetype/\* \
+	  ! -path $(CURDIR)/src/3rdparty/zlib/\* \
+	  ! -path $(CURDIR)/src/3rdparty/ptmalloc/Makefile \
+	-print0 | xargs -0 rm -rfv
+
+	# Any remaining executables
